<script setup lang="ts">
import BootstrapModal from "@/components/modals/BootstrapModal.vue";
import { useOTRStore } from "@/stores/otrs";
import { computed, onMounted, ref } from "vue";
import {
  type OwnershipTransferRequestOut,
  OwnershipTypeEnum,
} from "@/client/types.gen";
import { useNameStore } from "@/stores/names";
import dayjs from "dayjs";
import FontAwesomeIcon from "@/components/FontAwesomeIcon.vue";
import { useUserStore } from "@/stores/users";
import BootstrapToast from "@/components/BootstrapToast.vue";
import { Toast } from "bootstrap";
import DeleteOtrModal from "@/components/modals/DeleteOtrModal.vue";

const otrRepository = useOTRStore();
const nameRepository = useNameStore();
const userRepository = useUserStore();
const randomIDSuffix = Math.random().toString(16).substring(2, 8);

let successToast: Toast | null = null;

const props = defineProps<{
  modalId: string;
  backModalId?: string;
  otrTargetId: string;
}>();

const accepted = ref<boolean>(false);
const otr = computed<OwnershipTransferRequestOut | undefined>(
  () => otrRepository.otrMapping[props.otrTargetId],
);

const emit = defineEmits<{
  (e: "deleted-otr", otr: OwnershipTransferRequestOut): void;
  (e: "accepted-otr", otr: OwnershipTransferRequestOut): void;
}>();

function acceptOtr(otr: OwnershipTransferRequestOut) {
  accepted.value = true;
  otrRepository.acceptOtr(otr).then(() => {
    emit("accepted-otr", otr);
    successToast?.show();
  });
}

function deleteOtr(otr?: OwnershipTransferRequestOut) {
  if (otr != undefined) {
    accepted.value = false;
    otrRepository.deleteOtr(otr).then(() => {
      emit("deleted-otr", otr);
      successToast?.show();
    });
  }
}

onMounted(() => {
  successToast = Toast.getOrCreateInstance(
    `#success-handle-otr-${randomIDSuffix}`,
  );
});
</script>

<template>
  <bootstrap-toast
    :toast-id="`success-handle-otr-${randomIDSuffix}`"
    color-class="success"
  >
    <template v-if="accepted" #default>
      Successfully accepted request
    </template>
    <template v-else #default> Successfully deleted request </template>
  </bootstrap-toast>
  <delete-otr-modal
    :modal-id="`delete-otr-modal-${randomIDSuffix}`"
    :otr-type="otr != undefined ? otr.target_type : OwnershipTypeEnum.BUCKET"
    :otr="otr"
    :back-modal-id="modalId"
    @confirm-delete="deleteOtr"
  />
  <bootstrap-modal
    :modal-id="props.modalId"
    :static-backdrop="true"
    size-modifier-modal="lg"
    :modal-label="`Show ${otr?.target_type} OTR`"
  >
    <template #header
      >Ownership transfer request for {{ otr?.target_type }}
      <b>{{ otr?.target_name }}</b></template
    >
    <template #extra-button>
      <font-awesome-icon
        v-if="
          userRepository.admin ||
          otr?.current_owner_uid === userRepository.currentUID
        "
        icon="fa-solid fa-trash"
        class="me-2 cursor-pointer hover-danger"
        data-bs-toggle="modal"
        :data-bs-target="`#delete-otr-modal-${randomIDSuffix}`"
      />
    </template>
    <template #body>
      <div v-if="otr">
        <div class="row g-3">
          <div class="col-md-6">
            <label for="otr-to-user" class="form-label">To</label>
            <input
              id="otr-to-user"
              readonly
              class="form-control"
              :value="nameRepository.getName(otr.new_owner_uid)"
            />
          </div>
          <div v-if="otr.current_owner_uid" class="col-md-6">
            <label for="otr-from-user" class="form-label">From</label>
            <input
              id="otr-from-user"
              class="form-control"
              :value="nameRepository.getName(otr.current_owner_uid)"
            />
          </div>
          <div class="col-md-6">
            <label for="otr-target-name" class="form-label text-capitalize"
              >{{ otr?.target_type }} name</label
            >
            <input
              id="otr-target-name"
              class="form-control"
              :value="otr.target_name"
            />
          </div>
          <div v-if="otr.current_owner_uid" class="col-md-6">
            <label for="otr-timestamp" class="form-label"
              >Request created at</label
            >
            <input
              id="otr-timestamp"
              type="datetime-local"
              class="form-control"
              readonly
              :value="
                dayjs.unix(otr.created_at ?? 0).format('YYYY-MM-DDTHH:mm')
              "
            />
          </div>
          <div class="col-12">
            <label for="otr-description" class="form-label text-capitalize"
              >{{ otr?.target_type }} description</label
            >
            <textarea
              id="otr-description"
              class="form-control"
              readonly
              rows="2"
              :value="otr.target_description"
            />
          </div>
          <div v-if="otr.comment?.trim().length !== 0" class="col-12">
            <label for="otr-comment" class="form-label">Request comment</label>
            <textarea
              id="otr-comment"
              class="form-control"
              readonly
              rows="2"
              :value="otr.comment"
            />
          </div>
        </div>
        <div
          v-if="
            userRepository.admin ||
            otr.new_owner_uid === userRepository.currentUID
          "
          class="row mt-3 justify-content-md-center"
        >
          <button
            type="button"
            class="btn btn-danger btn-lg col-5 mx-2"
            data-bs-dismiss="modal"
            @click="deleteOtr(otr)"
          >
            Reject
          </button>
          <button
            type="button"
            class="btn btn-success btn-lg col-5 mx-2"
            data-bs-dismiss="modal"
            @click="acceptOtr(otr)"
          >
            Accept
          </button>
        </div>
      </div>

      <div v-else>Noting to see</div>
    </template>
    <template #footer>
      <button
        type="button"
        class="btn btn-secondary"
        :data-bs-target="backModalId ? `#${backModalId}` : undefined"
        :data-bs-toggle="backModalId ? 'modal' : undefined"
        :data-bs-dismiss="backModalId ? undefined : 'modal'"
      >
        <template v-if="backModalId">Back</template>
        <template v-else>Close</template>
      </button>
    </template>
  </bootstrap-modal>
</template>

<style scoped></style>
